<?php

namespace Bydedi\I18nEditor;

use Bydedi\Container\ServiceProvider;
use Symfony\Component\DependencyInjection\Reference;

class I18nEditorServiceProvider extends ServiceProvider
{

    /**
     * Register the service provider.
     *
     * @return void
     */
    public function register()
    {
        if (!$this->serviceContainer->hasParameter('app.i18n_settings')) {
            $this->serviceContainer->setParameter('app.i18n_settings', [
                'table_name' => 'text',
                'text_code_collumn_name' => 'code',
                'text_columns' => [
                    'value',
                ],
                'lang_column' => 'lang',
            ]);
        }

        $this->serviceContainer->getDefinition('template')
            ->addMethodCall('addTemplateDir', [__DIR__ . '/views']);

        $this->serviceContainer->register('utils.text.i18n_editor', 'Bydedi\I18nEditor\I18nEditor')
            ->addArgument(new Reference('template'))
            ->addArgument(new Reference('database.connection'))
            ->addArgument('%app.i18n_settings%')
            ->addArgument(new Reference('utils.text'))
            ->addMethodCall('setRequestStack', [new Reference('request_stack')]);
        ;
    }
}
